using RealityStack.UnityExtensions;
using UnityEngine;

namespace RealityStack.OTSS.DigitalInk
{
    public class DigitalInkManager : MonoBehaviour
    {
        public bool isActive;
        public Material material;
        public Color color = Color.black;
        public float minDistanceBetweenPoints = 0.001f;
        public float radius = 0.001f;

        private GLPathRenderer _activePathRenderer;

        private void Update()
        {
            if (isActive)
            {
                if (_activePathRenderer == null)
                {
                    _activePathRenderer = new GameObject("GLPathRenderer").AddComponent<GLPathRenderer>();
                    _activePathRenderer.material = new Material(material);
                    _activePathRenderer.material.color = color;
                    _activePathRenderer.radius = radius;
                }

                if (_activePathRenderer.localPoints.Count == 0)
                {
                    _activePathRenderer.AddWorldPoint(transform.position);
                }
                else
                {
                    if (Vector3.Distance(_activePathRenderer.localPoints[^1], transform.position) > minDistanceBetweenPoints)
                    {
                        _activePathRenderer.AddWorldPoint(transform.position);
                    }
                }
            }
            else
            {
                _activePathRenderer = null;
            }
        }
    }
}